#include "KeyBindWindow.hpp"
#include <stdio.h>
#include "KeyBind.hpp"
#include "resource.h"
#include "StringTable.hpp"
#include "MainWindow.hpp"

KeyBindWindow::KeyBindWindow(HINSTANCE instanceHandle, HWND parentWindowHandle, KeyBind* keyBind)
: initialized_(false), instanceHandle_(instanceHandle), windowHandle_(nullptr), parentWindowHandle_(parentWindowHandle), keyBind_(keyBind), targetIndex_(-1), currentKey_(0), modifierKeyState_(0)
{
	static int staticInitialize = registerWindowClass(instanceHandle);
}

KeyBindWindow::~KeyBindWindow()
{
}

bool KeyBindWindow::initialize()
{
	if (initialized_)
		return false;
	initialized_ = true;

	// 쐬EBhẼX^C
	DWORD windowStype = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU;

	// NCAg̈悩EBhETCYvZ
	int width = CLIENT_WIDTH;
	int height = CLIENT_HEIGHT;
	RECT clientRect = { 0, 0, width, height };
	if (AdjustWindowRect(&clientRect, windowStype, FALSE))
	{
		width = clientRect.right - clientRect.left;
		height = clientRect.bottom - clientRect.top;
	}

	// ʒʒuƂ
	int x = GetSystemMetrics(SM_CXSCREEN);
	int y = GetSystemMetrics(SM_CYSCREEN);
	x = x > width ? (x - width) / 2 : 0;
	y = y > height ? (y - height) / 2 : 0;

	// Window쐬
	windowHandle_ = CreateWindowEx(0, WINDOW_CLASS_NAME, StringTable::get(IDS_KEYBINDWINDOW_CAPTION), windowStype, x, y, width, height, nullptr, nullptr, instanceHandle_, nullptr);
	if (windowHandle_ == nullptr)
	{
		MessageBox(parentWindowHandle_, StringTable::get(IDS_ERROR_CREATE_WINDOW), StringTable::get(IDS_ERRORDIALOG_CAPTION), ERROR_DIALOG_TYPE);
		return false;
	}

	// Window procedurepthis|C^L
	SetWindowLongPtr(windowHandle_, GWLP_USERDATA, 0);
	if (SetWindowLongPtr(windowHandle_, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(this)) == 0 && GetLastError() != 0)
		goto DESTROY;


	// ݒΏۂ̋@\\
	targetTextHandle_ = CreateWindow(_T("STATIC"), _T(""), WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTERIMAGE | SS_LEFT, (CLIENT_WIDTH - (160 + 8 + 256 + 8 + 64)) / 2, 8, 160, 30, windowHandle_, nullptr, instanceHandle_, nullptr);
	if (targetTextHandle_ == nullptr)
		goto DESTROY;

	// Vݒ肷L[͂\
	currentKeyTextHandle_ = CreateWindow(_T("STATIC"), _T(""), WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTERIMAGE | SS_LEFT, (CLIENT_WIDTH - (160 + 8 + 256 + 8 + 64)) / 2 + 160 + 8, 8, 256, 30, windowHandle_, nullptr, instanceHandle_, nullptr);
	if (currentKeyTextHandle_ == nullptr)
		goto DESTROY;

	// ݒ{^
	commitButtonHandle_ = CreateWindow(_T("BUTTON"), StringTable::get(IDS_KEYBINDWINDOW_COMMIT_BUTTON), WS_CHILD | WS_VISIBLE | WS_BORDER | BS_PUSHBUTTON | BS_CENTER, (CLIENT_WIDTH - (160 + 8 + 256 + 8 + 64)) / 2 + 160 + 8 + 256 + 8, 8, 64, 30, windowHandle_, reinterpret_cast<HMENU>(ID_BUTTON_COMMIT), instanceHandle_, nullptr);
	if (commitButtonHandle_ == nullptr)
		goto DESTROY;

	// K̃L[oCh\
	for (int x = 0; x < 3; ++x)
	{
		for (int y = 0; y < 12; ++y)
		{
			int index = x * 12 + y;

			// ΏۉK\({^)
			selectButtonHandles_[index] = CreateWindow(_T("BUTTON"), StringTable::get(KEY_BIND_NAME_RESOURCE_IDS[index]), WS_CHILD | WS_VISIBLE | WS_BORDER | BS_PUSHBUTTON | BS_LEFT, 16 + (128 + 8 + 128 + 24) * x, 8 + 30 + 32 + (30 + 8) * y, 128, 30, windowHandle_, reinterpret_cast<HMENU>(static_cast<size_t>(index)), instanceHandle_, nullptr);
			if (selectButtonHandles_[index] == nullptr)
				goto DESTROY;

			// ΏۃL[oCh\
			keyTextHandles_[index] = CreateWindow(_T("STATIC"), keyBindToString(keyBind_->get(index)), WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTERIMAGE | SS_LEFT, 16 + 128 + 8 + (128 + 8 + 128 + 24) * x, 8 + 30 + 32 + (30 + 8) * y, 128, 30, windowHandle_, nullptr, instanceHandle_, nullptr);
			if (keyTextHandles_[index] == nullptr)
				goto DESTROY;
		}
	}

	int index = 2 * 12 + 12;

	// ΏۉK\({^)
	selectButtonHandles_[index] = CreateWindow(_T("BUTTON"), StringTable::get(KEY_BIND_NAME_RESOURCE_IDS[index]), WS_CHILD | WS_VISIBLE | WS_BORDER | BS_PUSHBUTTON | BS_LEFT, 16 + (128 + 8 + 128 + 24) * 2, 8 + 30 + 32 + (30 + 8) * 12, 128, 30, windowHandle_, reinterpret_cast<HMENU>(static_cast<size_t>(index)), instanceHandle_, nullptr);
	if (selectButtonHandles_[index] == nullptr)
		goto DESTROY;

	// ΏۃL[oCh\
	keyTextHandles_[index] = CreateWindow(_T("STATIC"), keyBindToString(keyBind_->get(index)), WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTERIMAGE | SS_LEFT, 16 + 128 + 8 + (128 + 8 + 128 + 24) * 2, 8 + 30 + 32 + (30 + 8) * 12, 128, 30, windowHandle_, nullptr, instanceHandle_, nullptr);
	if (keyTextHandles_[index] == nullptr)
		goto DESTROY;

	// zbgL[: Đ/~
	++index;
	selectButtonHandles_[index] = CreateWindow(_T("BUTTON"), StringTable::get(KEY_BIND_NAME_RESOURCE_IDS[index]), WS_CHILD | WS_VISIBLE | WS_BORDER | BS_PUSHBUTTON | BS_LEFT, (CLIENT_WIDTH - (160 + 8 + 256)) / 2, 8 + 30 + 32 + (30 + 8) * 13, 160, 30, windowHandle_, reinterpret_cast<HMENU>(static_cast<size_t>(index)), instanceHandle_, nullptr);
	if (selectButtonHandles_[index] == nullptr)
		goto DESTROY;

	keyTextHandles_[index] = CreateWindow(_T("STATIC"), keyBindToString(keyBind_->get(index)), WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTERIMAGE | SS_LEFT, (CLIENT_WIDTH - (160 + 8 + 256)) / 2 + 8 + 160, 8 + 30 + 32 + (30 + 8) * 13, 256, 30, windowHandle_, nullptr, instanceHandle_, nullptr);
	if (keyTextHandles_[index] == nullptr)
		goto DESTROY;

	// zbgL[: MIDI
	++index;
	selectButtonHandles_[index] = CreateWindow(_T("BUTTON"), StringTable::get(KEY_BIND_NAME_RESOURCE_IDS[index]), WS_CHILD | WS_VISIBLE | WS_BORDER | BS_PUSHBUTTON | BS_LEFT, (CLIENT_WIDTH - (160 + 8 + 256)) / 2, 8 + 30 + 32 + (30 + 8) * 14, 160, 30, windowHandle_, reinterpret_cast<HMENU>(static_cast<size_t>(index)), instanceHandle_, nullptr);
	if (selectButtonHandles_[index] == nullptr)
		goto DESTROY;

	keyTextHandles_[index] = CreateWindow(_T("STATIC"), keyBindToString(keyBind_->get(index)), WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTERIMAGE | SS_LEFT, (CLIENT_WIDTH - (160 + 8 + 256)) / 2 + 8 + 160, 8 + 30 + 32 + (30 + 8) * 14, 256, 30, windowHandle_, nullptr, instanceHandle_, nullptr);
	if (keyTextHandles_[index] == nullptr)
		goto DESTROY;

	// zbgL[: S~
	++index;
	selectButtonHandles_[index] = CreateWindow(_T("BUTTON"), StringTable::get(KEY_BIND_NAME_RESOURCE_IDS[index]), WS_CHILD | WS_VISIBLE | WS_BORDER | BS_PUSHBUTTON | BS_LEFT, (CLIENT_WIDTH - (160 + 8 + 256)) / 2, 8 + 30 + 32 + (30 + 8) * 15, 160, 30, windowHandle_, reinterpret_cast<HMENU>(static_cast<size_t>(index)), instanceHandle_, nullptr);
	if (selectButtonHandles_[index] == nullptr)
		goto DESTROY;

	keyTextHandles_[index] = CreateWindow(_T("STATIC"), keyBindToString(keyBind_->get(index)), WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTERIMAGE | SS_LEFT, (CLIENT_WIDTH - (160 + 8 + 256)) / 2 + 8 + 160, 8 + 30 + 32 + (30 + 8) * 15, 256, 30, windowHandle_, nullptr, instanceHandle_, nullptr);
	if (keyTextHandles_[index] == nullptr)
		goto DESTROY;

	// Window\
	ShowWindow(windowHandle_, SW_SHOW);

	return true;

DESTROY:

	MessageBox(windowHandle_, StringTable::get(IDS_ERROR_CREATE_WINDOW), StringTable::get(IDS_ERRORDIALOG_CAPTION), ERROR_DIALOG_TYPE);
	PostMessage(windowHandle_, WM_CLOSE, 0, 0);
	run();
	return false;
}

void KeyBindWindow::run()
{
	MSG message;
	for (valid_ = true; valid_;)
	{
		BOOL result = GetMessage(&message, windowHandle_, 0, 0);
		if (result == 0 || result == -1)
			break;
		DispatchMessage(&message);
	}
}

const int KeyBindWindow::KEY_BIND_NAME_RESOURCE_IDS[KeyBind::Index::LENGTH] =
{
	IDS_KEYBINDWINDOW_NOTE_C3,
	IDS_KEYBINDWINDOW_NOTE_CS3,
	IDS_KEYBINDWINDOW_NOTE_D3,
	IDS_KEYBINDWINDOW_NOTE_DS3,
	IDS_KEYBINDWINDOW_NOTE_E3,
	IDS_KEYBINDWINDOW_NOTE_F3,
	IDS_KEYBINDWINDOW_NOTE_FS3,
	IDS_KEYBINDWINDOW_NOTE_G3,
	IDS_KEYBINDWINDOW_NOTE_GS3,
	IDS_KEYBINDWINDOW_NOTE_A3,
	IDS_KEYBINDWINDOW_NOTE_AS3,
	IDS_KEYBINDWINDOW_NOTE_B3,
	IDS_KEYBINDWINDOW_NOTE_C4,
	IDS_KEYBINDWINDOW_NOTE_CS4,
	IDS_KEYBINDWINDOW_NOTE_D4,
	IDS_KEYBINDWINDOW_NOTE_DS4,
	IDS_KEYBINDWINDOW_NOTE_E4,
	IDS_KEYBINDWINDOW_NOTE_F4,
	IDS_KEYBINDWINDOW_NOTE_FS4,
	IDS_KEYBINDWINDOW_NOTE_G4,
	IDS_KEYBINDWINDOW_NOTE_GS4,
	IDS_KEYBINDWINDOW_NOTE_A4,
	IDS_KEYBINDWINDOW_NOTE_AS4,
	IDS_KEYBINDWINDOW_NOTE_B4,
	IDS_KEYBINDWINDOW_NOTE_C5,
	IDS_KEYBINDWINDOW_NOTE_CS5,
	IDS_KEYBINDWINDOW_NOTE_D5,
	IDS_KEYBINDWINDOW_NOTE_DS5,
	IDS_KEYBINDWINDOW_NOTE_E5,
	IDS_KEYBINDWINDOW_NOTE_F5,
	IDS_KEYBINDWINDOW_NOTE_FS5,
	IDS_KEYBINDWINDOW_NOTE_G5,
	IDS_KEYBINDWINDOW_NOTE_GS5,
	IDS_KEYBINDWINDOW_NOTE_A5,
	IDS_KEYBINDWINDOW_NOTE_AS5,
	IDS_KEYBINDWINDOW_NOTE_B5,
	IDS_KEYBINDWINDOW_NOTE_C6,
	IDS_KEYBINDWINDOW_BIND_HOTKEY_PLAY,
	IDS_KEYBINDWINDOW_BIND_MIDI_INPUT,
	IDS_KEYBINDWINDOW_BIND_ALL_STOP,
};

const TCHAR* const KeyBindWindow::VIRTUAL_KEY_NAMES[256] =
{
	/*0x00*/nullptr,
	/*0x01*/nullptr,
	/*0x02*/nullptr,
	/*0x03*/nullptr,
	/*0x04*/nullptr,
	/*0x05*/nullptr,
	/*0x06*/nullptr,
	/*0x07*/nullptr,
	/*0x08*/_T("Backspace"),
	/*0x09*/_T("Tab"),
	/*0x0a*/nullptr,
	/*0x0b*/nullptr,
	/*0x0c*/nullptr,
	/*0x0d*/_T("Enter"),
	/*0x0e*/nullptr,
	/*0x0f*/nullptr,
	/*0x10*/nullptr,
	/*0x11*/nullptr,
	/*0x12*/nullptr,
	/*0x13*/_T("Pause"),
	/*0x14*/nullptr,
	/*0x15*/nullptr,
	/*0x16*/nullptr,
	/*0x17*/nullptr,
	/*0x18*/nullptr,
	/*0x19*/nullptr,
	/*0x1a*/nullptr,
	/*0x1b*/_T("Esc"),
	/*0x1c*/nullptr,
	/*0x1d*/nullptr,
	/*0x1e*/nullptr,
	/*0x1f*/nullptr,
	/*0x20*/_T("Space"),
	/*0x21*/_T("PageUp"),
	/*0x22*/_T("PageDown"),
	/*0x23*/_T("End"),
	/*0x24*/_T("Home"),
	/*0x25*/_T("Left"),
	/*0x26*/_T("Up"),
	/*0x27*/_T("Right"),
	/*0x28*/_T("Down"),
	/*0x29*/nullptr,
	/*0x2a*/nullptr,
	/*0x2b*/nullptr,
	/*0x2c*/_T("PrintScreen"),
	/*0x2d*/_T("Insert"),
	/*0x2e*/_T("Delete"),
	/*0x2f*/nullptr,
	/*0x30*/_T("0"),
	/*0x31*/_T("1"),
	/*0x32*/_T("2"),
	/*0x33*/_T("3"),
	/*0x34*/_T("4"),
	/*0x35*/_T("5"),
	/*0x36*/_T("6"),
	/*0x37*/_T("7"),
	/*0x38*/_T("8"),
	/*0x39*/_T("9"),
	/*0x3a*/nullptr,
	/*0x3b*/nullptr,
	/*0x3c*/nullptr,
	/*0x3d*/nullptr,
	/*0x3e*/nullptr,
	/*0x3f*/nullptr,
	/*0x40*/nullptr,
	/*0x41*/_T("A"),
	/*0x42*/_T("B"),
	/*0x43*/_T("C"),
	/*0x44*/_T("D"),
	/*0x45*/_T("E"),
	/*0x46*/_T("F"),
	/*0x47*/_T("G"),
	/*0x48*/_T("H"),
	/*0x49*/_T("I"),
	/*0x4a*/_T("J"),
	/*0x4b*/_T("K"),
	/*0x4c*/_T("L"),
	/*0x4d*/_T("M"),
	/*0x4e*/_T("N"),
	/*0x4f*/_T("O"),
	/*0x50*/_T("P"),
	/*0x51*/_T("Q"),
	/*0x52*/_T("R"),
	/*0x53*/_T("S"),
	/*0x54*/_T("T"),
	/*0x55*/_T("U"),
	/*0x56*/_T("V"),
	/*0x57*/_T("W"),
	/*0x58*/_T("X"),
	/*0x59*/_T("Y"),
	/*0x5a*/_T("Z"),
	/*0x5b*/nullptr,
	/*0x5c*/nullptr,
	/*0x5d*/nullptr,
	/*0x5e*/nullptr,
	/*0x5f*/nullptr,
	/*0x60*/_T("Num0"),
	/*0x61*/_T("Num1"),
	/*0x62*/_T("Num2"),
	/*0x63*/_T("Num3"),
	/*0x64*/_T("Num4"),
	/*0x65*/_T("Num5"),
	/*0x66*/_T("Num6"),
	/*0x67*/_T("Num7"),
	/*0x68*/_T("Num8"),
	/*0x69*/_T("Num9"),
	/*0x6a*/_T("Num*"),
	/*0x6b*/_T("Num+"),
	/*0x6c*/nullptr,
	/*0x6d*/_T("Num-"),
	/*0x6e*/_T("Num."),
	/*0x6f*/_T("Num/"),
	/*0x70*/_T("F1"),
	/*0x71*/_T("F2"),
	/*0x72*/_T("F3"),
	/*0x73*/_T("F4"),
	/*0x74*/_T("F5"),
	/*0x75*/_T("F6"),
	/*0x76*/_T("F7"),
	/*0x77*/_T("F8"),
	/*0x78*/_T("F9"),
	/*0x79*/_T("F10"),
	/*0x7a*/_T("F11"),
	/*0x7b*/_T("F12"),
	/*0x7c*/nullptr,
	/*0x7d*/nullptr,
	/*0x7e*/nullptr,
	/*0x7f*/nullptr,
	/*0x80*/nullptr,
	/*0x81*/nullptr,
	/*0x82*/nullptr,
	/*0x83*/nullptr,
	/*0x84*/nullptr,
	/*0x85*/nullptr,
	/*0x86*/nullptr,
	/*0x87*/nullptr,
	/*0x88*/nullptr,
	/*0x89*/nullptr,
	/*0x8a*/nullptr,
	/*0x8b*/nullptr,
	/*0x8c*/nullptr,
	/*0x8d*/nullptr,
	/*0x8e*/nullptr,
	/*0x8f*/nullptr,
	/*0x90*/nullptr,
	/*0x91*/_T("ScrollLock"),
	/*0x92*/nullptr,
	/*0x93*/nullptr,
	/*0x94*/nullptr,
	/*0x95*/nullptr,
	/*0x96*/nullptr,
	/*0x97*/nullptr,
	/*0x98*/nullptr,
	/*0x99*/nullptr,
	/*0x9a*/nullptr,
	/*0x9b*/nullptr,
	/*0x9c*/nullptr,
	/*0x9d*/nullptr,
	/*0x9e*/nullptr,
	/*0x9f*/nullptr,
	/*0xa0*/nullptr,
	/*0xa1*/nullptr,
	/*0xa2*/nullptr,
	/*0xa3*/nullptr,
	/*0xa4*/nullptr,
	/*0xa5*/nullptr,
	/*0xa6*/nullptr,
	/*0xa7*/nullptr,
	/*0xa8*/nullptr,
	/*0xa9*/nullptr,
	/*0xaa*/nullptr,
	/*0xab*/nullptr,
	/*0xac*/nullptr,
	/*0xad*/nullptr,
	/*0xae*/nullptr,
	/*0xaf*/nullptr,
	/*0xb0*/nullptr,
	/*0xb1*/nullptr,
	/*0xb2*/nullptr,
	/*0xb3*/nullptr,
	/*0xb4*/nullptr,
	/*0xb5*/nullptr,
	/*0xb6*/nullptr,
	/*0xb7*/nullptr,
	/*0xb8*/nullptr,
	/*0xb9*/nullptr,
	/*0xba*/_T(":"),
	/*0xbb*/_T(";"),
	/*0xbc*/_T(","),
	/*0xbd*/_T("-"),
	/*0xbe*/_T("."),
	/*0xbf*/_T("/"),
	/*0xc0*/_T("@"),
	/*0xc1*/nullptr,
	/*0xc2*/nullptr,
	/*0xc3*/nullptr,
	/*0xc4*/nullptr,
	/*0xc5*/nullptr,
	/*0xc6*/nullptr,
	/*0xc7*/nullptr,
	/*0xc8*/nullptr,
	/*0xc9*/nullptr,
	/*0xca*/nullptr,
	/*0xcb*/nullptr,
	/*0xcc*/nullptr,
	/*0xcd*/nullptr,
	/*0xce*/nullptr,
	/*0xcf*/nullptr,
	/*0xd0*/nullptr,
	/*0xd1*/nullptr,
	/*0xd2*/nullptr,
	/*0xd3*/nullptr,
	/*0xd4*/nullptr,
	/*0xd5*/nullptr,
	/*0xd6*/nullptr,
	/*0xd7*/nullptr,
	/*0xd8*/nullptr,
	/*0xd9*/nullptr,
	/*0xda*/nullptr,
	/*0xdb*/_T("["),
	/*0xdc*/_T("\\"),
	/*0xdd*/_T("]"),
	/*0xde*/_T("^"),
	/*0xdf*/nullptr,
	/*0xe0*/nullptr,
	/*0xe1*/nullptr,
	/*0xe2*/_T("\\"),
	/*0xe3*/nullptr,
	/*0xe4*/nullptr,
	/*0xe5*/nullptr,
	/*0xe6*/nullptr,
	/*0xe7*/nullptr,
	/*0xe8*/nullptr,
	/*0xe9*/nullptr,
	/*0xea*/nullptr,
	/*0xeb*/nullptr,
	/*0xec*/nullptr,
	/*0xed*/nullptr,
	/*0xee*/nullptr,
	/*0xef*/nullptr,
	/*0xf0*/nullptr,
	/*0xf1*/nullptr,
	/*0xf2*/nullptr,
	/*0xf3*/nullptr,
	/*0xf4*/nullptr,
	/*0xf5*/nullptr,
	/*0xf6*/nullptr,
	/*0xf7*/nullptr,
	/*0xf8*/nullptr,
	/*0xf9*/nullptr,
	/*0xfa*/nullptr,
	/*0xfb*/nullptr,
	/*0xfc*/nullptr,
	/*0xfd*/nullptr,
	/*0xfe*/nullptr,
	/*0xff*/nullptr,
};

int KeyBindWindow::registerWindowClass(HINSTANCE instanceHandle)
{
	// Ă㏑邾ővȋC邯
	// ꉞŏ1񂾂o^΂Ȃ̂ł̂悤ɏĂ
	WNDCLASSEX wcex;
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.lpszClassName = WINDOW_CLASS_NAME;
	wcex.hInstance = instanceHandle;
	wcex.style = 0;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.lpszMenuName = nullptr;
	wcex.hbrBackground = BACKGROUND_BRUSH;
	wcex.hIcon = (HCURSOR)LoadImage(instanceHandle, MAKEINTRESOURCE(IDI_ICON1), IMAGE_ICON, 0, 0, LR_DEFAULTSIZE);
	wcex.hIconSm = (HCURSOR)LoadImage(instanceHandle, MAKEINTRESOURCE(IDI_ICON1), IMAGE_ICON, 0, 0, LR_DEFAULTSIZE);
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.lpfnWndProc = callbackProcedure;
	RegisterClassEx(&wcex);

	return 0;
}

LRESULT WINAPI KeyBindWindow::callbackProcedure(HWND windowHandle, UINT message, WPARAM wParam, LPARAM lParam)
{
	KeyBindWindow* window = reinterpret_cast<KeyBindWindow*>(GetWindowLongPtr(windowHandle, GWLP_USERDATA));
	if (window != nullptr)
		return window->procedure(windowHandle, message, wParam, lParam);
	else
		return DefWindowProc(windowHandle, message, wParam, lParam);
}

LRESULT KeyBindWindow::procedure(HWND windowHandle, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_COMMAND:
		{
			int index = LOWORD(wParam);
			if (0 <= index && index < KeyBind::Index::LENGTH)
			{
				// IꂽL[oChΏۂ̔ԍL^
				targetIndex_ = index;

				// IꂽL[oChΏۂ\
				SetWindowText(targetTextHandle_, StringTable::get(KEY_BIND_NAME_RESOURCE_IDS[index]));

				// {^ɍstH[JXEBhEɖ߂(L[͂邽)
				SetFocus(windowHandle);
				return 0;
			}
			else if (index == ID_BUTTON_COMMIT)
			{
				if (targetIndex_ < 0 || currentKey_ == 0)
					return 0;

				// m[gɂ͏CL[͎gpoȂ
				if (KeyBind::Index::NOTE_NUMBER <= targetIndex_ && targetIndex_ <= KeyBind::Index::NOTE_NUMBER + MAXIMUM_NOTE_NUMBER - MINIMUM_NOTE_NUMBER && (currentKey_ & 0xff00) != 0)
				{
					MessageBox(windowHandle, StringTable::get(IDS_ERROR_REGISTER_NOTE_MODIFIRE_KEY), StringTable::get(IDS_ERRORDIALOG_CAPTION), ERROR_DIALOG_TYPE);
					return 0;
				}

				// L[oChXV
				keyBind_->set(targetIndex_, currentKey_);

				// L[oCh̕\XV
				for (size_t i = 0; i < KeyBind::Index::LENGTH; ++i)
					SetWindowText(keyTextHandles_[i], keyBindToString(keyBind_->get(i)));

				// {^ɍstH[JXEBhEɖ߂(L[͂邽)
				SetFocus(windowHandle);
				return 0;
			}
		}
		break;

	case WM_SYSKEYDOWN:
	case WM_KEYDOWN:
		wParam &= 0xff;
		if (wParam == VK_CONTROL)
			modifierKeyState_ |= KeyBind::ModifierKey::CONTROL;
		else if (wParam == VK_SHIFT)
			modifierKeyState_ |= KeyBind::ModifierKey::SHIFT;
		else if (wParam == VK_MENU)
			modifierKeyState_ |= KeyBind::ModifierKey::ALTERNATE;
		break;

	case WM_SYSKEYUP:
	case WM_KEYUP:
		wParam &= 0xff;
		if (wParam == VK_CONTROL)
			modifierKeyState_ &= ~KeyBind::ModifierKey::CONTROL;
		else if (wParam == VK_SHIFT)
			modifierKeyState_ &= ~KeyBind::ModifierKey::SHIFT;
		else if (wParam == VK_MENU)
			modifierKeyState_ &= ~KeyBind::ModifierKey::ALTERNATE;
		else if (VIRTUAL_KEY_NAMES[wParam] != nullptr)
		{
			currentKey_ = static_cast<WORD>(wParam) | modifierKeyState_;
			SetWindowText(currentKeyTextHandle_, keyBindToString(currentKey_));
			return 0;
		}
		break;

	case WM_CTLCOLORSTATIC:
		SetBkMode(reinterpret_cast<HDC>(wParam), TRANSPARENT);
		return reinterpret_cast<LRESULT>(BACKGROUND_BRUSH);

	case WM_CLOSE:
		DestroyWindow(windowHandle);
		return 0;

	case WM_DESTROY:
		// ͂Ő䂵ȂĂGetMessage-1ԂăG[ƂďI񂾂ǈꉞ䂷
		valid_ = false;
		return 0;
	}

	return DefWindowProc(windowHandle, message, wParam, lParam);
}

const TCHAR* KeyBindWindow::keyBindToString(WORD key)
{
	if (key == 0)
	{
		keyTextBuffer_[0] = 0;
		return 0;
	}

	// {ݒoȂlݒt@C̒ڕҏWɂݒ肵ĂP[XȂ̂łƂƂŉ\Ȃ
	if (VIRTUAL_KEY_NAMES[key & 0xff] == nullptr)
	{
		keyTextBuffer_[0] = 0;
		return 0;
	}

	int written = 1;
	keyTextBuffer_[0] = ' ';

	if ((key & KeyBind::ModifierKey::CONTROL) != 0)
		written += _stprintf_s(&keyTextBuffer_[written], KEY_TEXT_BUFFER_LENGTH - written, _T("Ctrl + "));

	if ((key & KeyBind::ModifierKey::ALTERNATE) != 0)
		written += _stprintf_s(&keyTextBuffer_[written], KEY_TEXT_BUFFER_LENGTH - written, _T("Alt + "));

	if ((key & KeyBind::ModifierKey::SHIFT) != 0)
		written += _stprintf_s(&keyTextBuffer_[written], KEY_TEXT_BUFFER_LENGTH - written, _T("Shift + "));

	_stprintf_s(&keyTextBuffer_[written], KEY_TEXT_BUFFER_LENGTH - written, VIRTUAL_KEY_NAMES[key & 0xff]);

	return keyTextBuffer_;
}
